/*!
 * \file   /utl/core/types.h
 * \brief  Basic type alias support
 *
 * Copyright (C) 2018 Christos Choutouridis
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#ifndef __utl_core_types_h__
#define __utl_core_types_h__

#include <cstddef>
#include <cstdint>

//#include <type_traits>

namespace utl {
   //! @{ \name byte and word types
   using byte_t   = uint8_t;     //!< 8 bits wide
   using word_t   = uint16_t;    //!< 16 bits wide
   using dword_t  = uint32_t;    //!< 32 bits wide
   //! @}

   //! @{ \name size and index
   using size_t   = std::size_t;
   using index_t  = size_t;      //!< index_t and size_t mend to be interchangeable

   using ptrdiff_t= std::ptrdiff_t;
   //! @}
}

#endif /* __utl_core_types_h__ */
